<?php

class WpbcDb{
	private $wpdb;
	private $backlinks_table;
	private $backlinks_groups_table;

	public function __construct( $wpdb ){
		$this->wpdb 				= $wpdb;
		$this->backlinks_table			= $this->wpdb->prefix . "wpbc_backlinks";
		$this->backlinks_groups_table 		= $this->wpdb->prefix . "wpbc_backlinks_groups";
	}
	public function insert_backlink_group( $data ){
		$this->wpdb->show_errors();

		$this->wpdb->insert( $this->backlinks_groups_table, 
					array(
					'timestamp'	=> time(),
					'description'	=> $data['description'],
					'remind_days'	=> $data['remind_days'],
					'creator_id'	=> $data['creator_id'],
					'notify'		=> $data['notify'],
					'remind'		=> $data['remind'],
					'name'			=> $data['name']
					)
		);
		return $this->wpdb->insert_id;
	}
	public function insert_backlink( $data ){
		$this->wpdb->show_errors();

		$this->wpdb->insert( $this->backlinks_table, 
					array(
					'created'		=> time(),
					'timestamp'		=> time(),
					'url'			=> $data['url'],
					'name'			=> $data['name'],
					'site'			=> $data['site'],
					'status'		=> $data['status'],
					'notify'		=> $data['notify'],
					'remind'		=> $data['remind'],
					'group_id'		=> $data['group_id'],
					'remind_days'		=> $data['remind_days'],
					'expected_anchor'	=> $data['expected_anchor'],
					'discovered_anchor'	=> $data['discovered_anchor']
					)
		);
		return $this->wpdb->insert_id;
	}
	public function get_backlinks_groups( ){
		$this->wpdb->show_errors();
		$sql = "SELECT * FROM " . $this->backlinks_groups_table;
		return $this->wpdb->get_results($sql, ARRAY_A);
	}
	public function get_backlinks_group( $id ){
		$this->wpdb->show_errors();
		$sql = "SELECT * FROM " . $this->backlinks_groups_table . " WHERE id = '$id'";
		$temp = $this->wpdb->get_results($sql, ARRAY_A);
		return $temp[0];
	}
	public function get_all_backlinks( ){
		$this->wpdb->show_errors();
		$sql = "SELECT * FROM " . $this->backlinks_table;
		return $this->wpdb->get_results($sql, ARRAY_A);
	}
	public function get_backlinks_by_time( ){
		$this->wpdb->show_errors();
		$sql = "SELECT * FROM " . $this->backlinks_table .
			" ORDER BY timestamp ASC LIMIT 0, 50";
		return $this->wpdb->get_results($sql, ARRAY_A);
	}
	public function get_backlinks( $group_id ){
		$this->wpdb->show_errors();
		$sql = "SELECT * FROM " . $this->backlinks_table ." WHERE group_id = '$group_id'";
		return $this->wpdb->get_results($sql, ARRAY_A);
	}
	public function get_backlink( $b_id ){
		$this->wpdb->show_errors();
		$sql 	= "SELECT * FROM " . $this->backlinks_table ." WHERE id = '$b_id'";
		$temp 	= $this->wpdb->get_results( $sql, ARRAY_A);
		return $temp[0];
	}
	public function delete_backlink( $b_id ){
		$this->wpdb->show_errors();
		$sql_delete = "DELETE FROM ". $this->backlinks_table ." WHERE id = '$b_id'";
		return $this->wpdb->query( $sql_delete );
	}
	public function delete_backlinks_group( $id ){
		$this->wpdb->show_errors();
		$sql_delete = "DELETE FROM ". $this->backlinks_groups_table ." WHERE id = '$id' LIMIT 1";
		$this->wpdb->query( $sql_delete );
		$sql_delete = "DELETE FROM ". $this->backlinks_table ." WHERE group_id = '$id'";
		$this->wpdb->query( $sql_delete );
	}
	public function update_backlink_notify( $id, $notify ){
		$this->wpdb->show_errors();
		return $this->wpdb->update(  $this->backlinks_table,
					array(  'notify' => $notify),
					array(  'id' => $id )
				);	
	}
	public function edit_backlink( $data ){
		$this->wpdb->show_errors();
		return $this->wpdb->update(  $this->backlinks_table, 
					array(
						'remind_last'		=> time(),
						'url'			=> $data['url'],
						'name'			=> $data['name'],
						'site'			=> $data['site'],
						'status'		=> $data['status'],
						'expected_anchor'	=> $data['expected_anchor'],
						'discovered_anchor'	=> $data['discovered_anchor']), 
					array(  'id' => $data['id'])
				);	
	}
	public function update_backlink( $data, $flag = FALSE ){
		$this->wpdb->show_errors();
		if( $flag ){
			return $this->wpdb->update(  $this->backlinks_table, 
				array(  
						'discovered_anchor'	=> $data['discovered_anchor'],
						'remind_last'		=> time(),
						'timestamp'		=> time(),
				 		'status' 		=> $data['status'] ), 
					array(  'id' => $data['id'])
				);	
		} else{
			return $this->wpdb->update(  $this->backlinks_table, 
				array(  
						'discovered_anchor'	=> $data['discovered_anchor'],
						'timestamp'		=> time(),
				 		'status' 		=> $data['status'] ), 
					array(  'id' => $data['id'])
				);	
		}
	}
	public function update_backlink_group_notify( $id, $notify ){
	
		$this->wpdb->show_errors();
		$this->wpdb->update(  $this->backlinks_table, 
					array(  'notify' => $notify), 
					array(  'group_id' => $id )
				);
		$this->wpdb->update(  $this->backlinks_groups_table, 
					array(  'notify' => $notify), 
					array(  'id' => $id )
				);	
	}
	public function edit_backlink_group( $data ){
		$this->wpdb->show_errors();
		$this->wpdb->update(  $this->backlinks_groups_table, 
					array(
					'description'	=> $data['description'],
					'remind_days'	=> $data['remind_days'],
					'remind'		=> $data['remind'],
					'notify'		=> $data['notify'],
					'name'			=> $data['name']
					), 
					array(  'id' => $data['id'])
				);
		$this->wpdb->update(  $this->backlinks_table, 
					array(  
					'remind_days'	=> $data['remind_days'],
					'notify'	=> $data['notify'],
					'remind'	=> $data['remind'] ), 
					array(  'group_id' => $data['id'] )
				);
	}
}
?>
