<?php
function wpbc_options_get($option){
	$data = unserialize(base64_decode(get_option('wpbc_options')));
	return $data[$option];
}
function wpbc_options_add($option, $value){
	$data = unserialize(base64_decode(get_option('wpbc_options')));
	$data[$option] = $value;
	$data = base64_encode(serialize($data));
	update_option('wpbc_options', $data);
}
function wpbc_process_status_code( $status_code ){
	switch( $status_code ){
		case -1:
			return 'Link doesn\'t exist';
		case 1:
			return 'Link exists';
		case 2:
			return 'Link exists, different anchor';
		case 3:
			return 'Link exists otherwise';
		default:
			return 'Link status unknown';
	}
}
function wpbc_clean_link( $url ){
	$temp = preg_replace("~^https?://[^/?]+$~", "$0/", $url);
	return $temp;
}
function wpbc_remove_protocol( $url ){
	$patterns 	= array();
	$replacements 	= array();
	$patterns[0] 		= '/http:\/\//';
	$patterns[1] 		= '/www./';
	$replacements[0] 	= '';
	$replacements[1] 	= '';
	$temp = preg_replace($patterns, $replacements, $url );
	return rtrim( $temp, '/');
}
function wpbc_check_all_backlinks(){
	global $wpdb;
	$data = array();
	$wpbcdb = new WpbcDb( $wpdb );
	$backlinks = $wpbcdb->get_all_backlinks( );
	foreach( $backlinks as $backlink ){
		wpbc_check_link( $backlink['id'] );
	}
}
function wpbc_check_link( $b_id ){
	if( TRUE ){
		global $wpdb;
		$data = array();
		$wpbcdb = new WpbcDb( $wpdb );
		$b = $wpbcdb->get_backlink( $b_id );
		$expected_url = $b['url'];
		$sites[0] = 'http://'. $b['site'];
		$sites[1] = 'http://www.'. $b['site'];
		$status = "-1";
		foreach( $sites as $site ){
			//var_dump( $site );
			$links = wpbc_get_links( $site );
			foreach( $links as $link ){
				$anchor_flag 	= substr_count( strtolower( trim($link['text']) ), 
							strtolower(trim($b['expected_anchor']) ) ) ;
				$link_flag 	= substr_count ( strtolower( trim($link['url']) ), 
							trim($expected_url) );
				//var_dump($link_flag);var_dump($link['url']);var_dump(trim($expected_url));
				//var_dump($anchor_flag);var_dump($link['text']);var_dump(trim($b['expected_anchor']));
				if( ( strtolower( trim($link['text']) ) == strtolower( trim($b['expected_anchor']) ) )
					 && $link_flag ){
					$status	= '1';
					$data['discovered_anchor'] = trim($link['text']);
				} elseif( $link_flag && $anchor_flag && ( $status != 1 )) {
					$status	= '2';	
					$data['discovered_anchor'] = trim($link['text']);					
				} elseif( $link_flag && ( $status != 2 )){
					$status	= '2';	
					$data['discovered_anchor'] = trim($link['text']);
				} else {
					
				}
				if( $status == '1'){
					break;
				}
				//var_dump( $status );
			}
			if( $status == '1'){
				break;
			}
		}
		$data['status']	= $status;
		
		if( ($data['discovered_anchor'] != $b['discovered_anchor']) && ($b['notify'] == 1)){
			$group = $wpbcdb->get_backlinks_group( $b['group_id'] );
			$site_url = get_option('siteurl');
			$backlink_group = $group['name'];
			$backlink_link = $b['url'];
			$backlink_site = $b['site'];
			$c_anchor = $data['discovered_anchor'];
			$e_anchor = $b['expected_anchor'];
			$d_anchor = $b['discovered_anchor'];
			$message = "<p>Hi,<br><br>".
		"You have recieved this email because <strong>WP Backlink Checker wordpress plugin<strong><br>".
		"has detected a change in the backlinks to one of the sites.<br><br>".
		"Backlink Group: $backlink_group<br>".
		"Backlink Link: $backlink_link<br>".
		"Site: $backlink_site<br>".
		"Current Anchor Text: $c_anchor<br>".
		"Expected Anchor Text: $e_anchor<br>".
		"Last Discovered Anchor Text: $d_anchor<br><br>".
		"$site_url<br></p>";
			//wpbc_send_mail( $message );
		}
		$data['id'] = $b_id;
		$wpbcdb->update_backlink( $data );
		return $b['group_id'];
	}
}
function wpbc_get_links( $url ) { 
  
    $xml = new DOMDocument(); 
    @$xml->loadHTMLFile( $url ); 
	$links = array(); 
  
    foreach($xml->getElementsByTagName('a') as $link) { 
        $links[] = array('url' => $link->getAttribute('href'), 'text' => $link->nodeValue); 
    } 
	return $links; 
}
function wpbc_check_array( $array, $string ){
	$t = count( $array );
	if( $t ){
		for( $i = 0; $i < $t; $i++ ){
			$flag = substr_count ( $array[$i], $string );
			if( $flag ){
	    			$ind = $i + 1;
				break;
			}
		}
	} else {

	}
	return $ind;
}
function wpbc_backlink_mail(){
	global $wpdb;
	$data 			= array();
	$wpbcdb			= new WpbcDb( $wpdb );
	$backlinks 		= $wpbcdb->get_all_backlinks( );

	$site_url 	= get_option('siteurl');
	$message = "<p>Hi,<br><br>".
		"This is a reminder to check the links below<br><br>".
		"<table style=\"padding:10px;border:1px solid #d4d4d4;border-collapse:collapse;\">".
		"<thead><tr>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Your URL Backlink</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Expected Anchor</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Site to Ckeck</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Group Name</th></tr></thead>".
		"<tfoot><tr>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Your URL Backlink</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Expected Anchor</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Site to Check</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Group Name</th></tr></tfoot><tbody>";
	$i = 0;
	foreach( $backlinks as $backlink ){
		$r_days = $backlink['remind_days'] ? $backlink['remind_days'] : '10000000000';
		$next_remind = $backlink['remind_last'] + ( $r_days * 20 * 60 * 60 );
		$flag = ( ( $next_remind - time() ) < 0 ) ? TRUE : FALSE;
		if( $flag ){
			$i++;
			$url 			= $backlink['url'];
			$anchor			= $backlink['expected_anchor'];
			$site			= $backlink['site'];
			$group			= $wpbcdb->get_backlinks_group( $backlink['group_id'] );
			$group_name		= $group['name'];
			$message .= "<tr style=\"padding:2px 5px;border:1px solid #d4d4d4;\">".
				"<td style=\"padding:2px 5px;border:1px solid #d4d4d4;\">$url</td>".
				"<td style=\"padding:2px 5px;border:1px solid #d4d4d4;\">$anchor</td>".
				"<td style=\"padding:2px 5px;border:1px solid #d4d4d4;\">$site</td>".
				"<td style=\"padding:2px 5px;border:1px solid #d4d4d4;\">$group_name</td></tr>";
				$wpbcdb->update_backlink( $backlink, TRUE );
		}
	}
	$message .= "</tbody></table><br><br>".
			"$site_url<br></p>";
	if( $i ){
		return $message;
	} else {
		return "";
	}
}
function wpbc_backlink_notify_mail(){
	global $wpdb;
	$data 			= array();
	$wpbcdb			= new WpbcDb( $wpdb );
	$backlinks 		= $wpbcdb->get_all_backlinks( );

	$site_url 	= get_option('siteurl');
	$message = "<p>Hi,<br><br>".
		"Please note that the following backlinks have unexpected/changed anchor text<br><br>".
		"<table style=\"padding:10px;border:1px solid #d4d4d4;border-collapse:collapse;\">".
		"<thead><tr>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Your URL Backlink</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Expected Anchor</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Discovered Anchor</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Site</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Group Name</th></tr></thead>".
		"<tfoot><tr>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Your URL Backlink</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Expected Anchor</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Discovered Anchor</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Site</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Group Name</th></tr></tfoot><tbody>";
	$i = 0;
	foreach( $backlinks as $backlink ){
		if( ( $backlink['expected_anchor'] != $backlink['discovered_anchor'] )
			&&  ($backlink['expected_anchor'] != '_') && $backlink['notify']){
			$i++;

			$url 			= $backlink['url'];
			$anchor			= $backlink['expected_anchor'];
			$d_anchor		= $backlink['discovered_anchor'];
			$site			= $backlink['site'];
			$group			= $wpbcdb->get_backlinks_group( $backlink['group_id'] );
			$group_name		= $group['name'];
			$bing_rank		= ( $bing_day['rank'] > 300 ) ? '>300' : $bing_day['rank'];
			$google_rank		= ( $google_day['rank'] > 300 ) ? '>300' : $google_day['rank'];
			$message .= "<tr style=\"padding:2px 5px;border:1px solid #d4d4d4;\">".
				"<td style=\"padding:2px 5px;border:1px solid #d4d4d4;\">$url</td>".
				"<td style=\"padding:2px 5px;border:1px solid #d4d4d4;\">$anchor</td>".
				"<td style=\"padding:2px 5px;border:1px solid #d4d4d4;\">$d_anchor</td>".
				"<td style=\"padding:2px 5px;border:1px solid #d4d4d4;\">$site</td>".
				"<td style=\"padding:2px 5px;border:1px solid #d4d4d4;\">$group_name</td></tr>";
				$wpbcdb->update_backlink( $backlink );
		}
	}
	$message .= "</tbody></table><br><br>".
			"$site_url<br></p>";
	if( $i ){
		return $message;
	} else {
		return "";
	}
}
function wpbc_weekly_serp_mail(){
	global $wpdb;
	$data 		= array();
	$wpbcdb		= new WpbcDb( $wpdb );
	$serps 		= $wpbcdb->get_all_serps( );

	$site_url 	= get_option('siteurl');
	$message = "<p>Hi,<br><br>".
		"On the last weekly check the SERP rankings where as follows<br><br>".
		"<table style=\"padding:10px;border:1px solid #d4d4d4;border-collapse:collapse;\">".
		"<thead><tr>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Keyword</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">URL</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Group Name</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Google Rank</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Bing Rank</th></tr></thead>".
		"<tfoot><tr>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Keyword</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">URL</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Group Name</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Google Rank</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Bing Rank</th></tr></tfoot><tbody>";
	foreach( $serps as $serp ){
		$bing_week 		= $wpbcdb->get_bing_week( $serp['id'] );
		$google_week 		= $wpbcdb->get_google_week( $serp['id'] );
		$group			= $wpbcdb->get_serps_group( $serp['group_id'] );
		$name			= $serp['keyword'];
		$url			= $serp['url'];
		$group_name		= $group['name'];
		$bing_rank		= ( $bing_week['rank'] > 300 ) ? '>300' : $bing_week['rank'] ;;
		$google_rank		= ( $google_week['rank'] > 300 ) ? '>300' : $google_week['rank'];
		$message .= "<tr style=\"padding:2px 5px;border:1px solid #d4d4d4;\">".
				"<td style=\"padding:2px 5px;border:1px solid #d4d4d4;\">$name</td>".
				"<td style=\"padding:2px 5px;border:1px solid #d4d4d4;\">$url</td>".
				"<td style=\"padding:2px 5px;border:1px solid #d4d4d4;\">$group_name</td>".
				"<td style=\"padding:2px 5px;border:1px solid #d4d4d4;\">$google_rank</td>".
				"<td style=\"padding:2px 5px;border:1px solid #d4d4d4;\">$bing_rank</td></tr>";
			
	}
	$message .= "</tbody></table><br><br>".
			"$site_url<br></p>";
	return $message;
}
function wpbc_monthly_serp_mail(){
	global $wpdb;
	$data 		= array();
	$wpbcdb		= new WpbcDb( $wpdb );
	$serps 		= $wpbcdb->get_all_serps( );

	$site_url 	= get_option('siteurl');
	$message = "<p>Hi,<br><br>".
		"On the last monthly check the SERP rankings where as follows<br><br>".
		"<table style=\"padding:10px;border:1px solid #d4d4d4;border-collapse:collapse;\">".
		"<thead><tr>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Keyword</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">URL</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Group Name</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Google Rank</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Bing Rank</th></tr></thead>".
		"<tfoot><tr>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Keyword</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">URL</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Group Name</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Google Rank</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Bing Rank</th></tr></tfoot><tbody>";
	foreach( $serps as $serp ){
		$bing_month 		= $wpbcdb->get_bing_month( $serp['id'] );
		$google_month		= $wpbcdb->get_google_month( $serp['id'] );
		$group			= $wpbcdb->get_serps_group( $serp['group_id'] );
		$name			= $serp['keyword'];
		$url			= $serp['url'];
		$group_name		= $group['name'];
		$bing_rank		= ( $bing_month['rank'] > 300 ) ? '>300' : $bing_month['rank'] ;;
		$google_rank		= ( $google_month['rank'] > 300 ) ? '>300' : $google_month['rank'];
		$message .= "<tr style=\"padding:2px 5px;border:1px solid #d4d4d4;\">".
				"<td style=\"padding:2px 5px;border:1px solid #d4d4d4;\">$name</td>".
				"<td style=\"padding:2px 5px;border:1px solid #d4d4d4;\">$url</td>".
				"<td style=\"padding:2px 5px;border:1px solid #d4d4d4;\">$group_name</td>".
				"<td style=\"padding:2px 5px;border:1px solid #d4d4d4;\">$google_rank</td>".
				"<td style=\"padding:2px 5px;border:1px solid #d4d4d4;\">$bing_rank</td></tr>";
			
	}
	$message .= "</tbody></table><br><br>".
			"$site_url<br></p>";
	return $message;
}
function wpbc_check_serp( $serp_id ){
	global $wpdb;
	$data 	= array();
	$wpbcdb	= new WpbcDb( $wpdb );
	$serp 	= $wpbcdb->get_serp( $serp_id );
	$data 	= array();
	$data['id']		= $serp_id;
	$data['bing_rank']	= wpbc_check_bing_rank( $serp['url'], $serp['keyword'] );
	$data['google_rank']	= wpbc_check_google_rank( $serp['url'], $serp['keyword'], $serp['google'] );
	//echo print_r( $data );
	
	//var_dump($data['bing_rank']);
	//var_dump($data['google_rank']);

	$wpbcdb	= new WpbcDb( $wpdb );
	$wpbcdb->get_serp( $serp_id );

	if( $data['bing_rank'] or $data['google_rank'] ){
		$wpbcdb	= new WpbcDb( $wpdb );
		$wpbcdb->update_serp( $data );

		$g_rank 	= $data['google_rank'];
		$g_day		= $wpbcdb->get_g_day( $serp_id );
		$g_week		= $wpbcdb->get_g_week( $serp_id );
		$g_month	= $wpbcdb->get_g_month( $serp_id );
		$b_rank 	= $data['bing_rank'];
		$b_day		= $wpbcdb->get_b_day( $serp_id );
		$b_week		= $wpbcdb->get_b_week( $serp_id );
		$b_month	= $wpbcdb->get_b_month( $serp_id );

		$day			= 24 * 60 * 60;
		$week			=  7 * 24 * 60 * 60;
		$month			= 30 * 24 * 60 * 60;
		$bing_day 		= $wpbcdb->get_bing_day( $serp_id );
		$bing_week		= $wpbcdb->get_bing_day( $serp_id );
		$bing_month 		= $wpbcdb->get_bing_day( $serp_id );
		$google_day 		= $wpbcdb->get_google_day( $serp_id );
		$google_week 		= $wpbcdb->get_google_week( $serp_id );
		$google_month 		= $wpbcdb->get_google_month( $serp_id );
		$data['serp_id'] 	= $serp_id;
		$data['group_id'] 	= $serp['group_id'];

		if( (( time() - $bing_day['timestamp']) > $day) or !count($bing_day)){
			$data['rank'] 	= $data['bing_rank'];
			$wpbcdb->insert_bing_day( $data );
		}
		if( ( time() - $bing_week['timestamp']) > $week or !count($bing_week)){
			$data['rank'] 	= $data['bing_rank'];
			$wpbcdb->insert_bing_week( $data );
		}
		if( ( time() - $bing_month['timestamp'] ) > $month or !count($bing_month)){
			$data['rank'] 	= $data['bing_rank'];
			$wpbcdb->insert_bing_month( $data );
		}
		if( ( time() - $google_day['timestamp']) > $day  or !count($google_day)){
			$data['rank'] 	= $data['google_rank'];
			$wpbcdb->insert_google_day( $data );
		}
		if( ( time() - $google_week['timestamp'] ) > $week or !count($google_week) ){
			$data['rank'] 	= $data['google_rank'];
			$wpbcdb->insert_google_week( $data );
		}
		if( ( time() -   $bing_month['timestamp']) > $month or !count($google_month) ){
			$data['rank'] 	= $data['google_rank'];
			$wpbcdb->insert_google_month( $data );
		}

		$notify 	= $serp['remind'];
		$notify_days 	= $serp['remind_days'];
		$notify_last 	= $serp['remind_last'] + ( $notify_days * 24 * 60 * 60 );

		if( $notify ){
			if( $notify_last > time()  ){
				$site_url 	= get_option('siteurl');
				$message = "<p>Hi,<br><br>".
		"Your SERP rankings for <br><br>".
		"Keyword:" . $serp['keyword'] .
		"URL:" . $serp['url'] . "<br><br>are as follows".
		"<table style=\"padding:10px;border:1px solid #d4d4d4;border-collapse:collapse;\">".
		"<thead><tr>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Google Rank</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Day</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Week</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Month</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Bing Rank</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Day</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Week</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Month</th></tr></thead>".
		"<tfoot><tr>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Google Rank</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Day</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Week</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Month</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Bing Rank</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Day</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Week</th>".
		"<th style=\"padding:5px;border:1px solid #d4d4d4;\">Month</th></tr></tfoot><tbody>".
		"<tr style=\"padding:2px 5px;border:1px solid #d4d4d4;\">".
		"<td style=\"padding:2px 5px;border:1px solid #d4d4d4;\">$g_rank</td>".
		"<td style=\"padding:2px 5px;border:1px solid #d4d4d4;\">$g_day</td>".
		"<td style=\"padding:2px 5px;border:1px solid #d4d4d4;\">$g_week</td>".
		"<td style=\"padding:2px 5px;border:1px solid #d4d4d4;\">$g_month</td>".
		"<td style=\"padding:2px 5px;border:1px solid #d4d4d4;\">$b_rank</td>".
		"<td style=\"padding:2px 5px;border:1px solid #d4d4d4;\">$b_day</td>".
		"<td style=\"padding:2px 5px;border:1px solid #d4d4d4;\">$b_week</td>".
		"<td style=\"padding:2px 5px;border:1px solid #d4d4d4;\">$b_month</td></tr>".
		"</tbody></table><br><br>".
		"$site_url<br></p>";
				//wpbc_send_mail( $message );
			}
		}
	} else {
		wpbc_options_add( 'wpbc_last_serp_run', '-1');	
	}
}
function wpbc_get_proxy( $de ){

	$pr = wpbc_options_get( 'wpbc_own_proxy');
	$t = wpbc_options_get( 'wpbc_proxy');
	$tp = ( $t > 1 ) ? 1 : 0;
	$count = count($pr);
	if( $count && $tp ){
		$count = rand( 0, ( $count - 1 ) );
		$proxy = explode(":", $pr[$count]);

		$temp 		= array();
		$temp['pass'] 	= $proxy[2] . ':' . $proxy[3] ;  
		$temp['port'] 	= $proxy[1];
		$temp['ip'] 	= $proxy[0]; 
		return $temp;
	} else {
		$su 		= urlencode(wpbc_encrypt( get_option( 'siteurl' ) ));
		$eu		= urlencode(wpbc_encrypt( wpbc_options_get( 'wpbc_email' )));
		$lu 		= urlencode(wpbc_encrypt( wpbc_options_get( 'wpbc_license' ) ));
		$url 		= "http://webranktracker.com/wpbc/proxy.php?lu=$lu&eu=$eu&su=$su&de=$de";
		$response	= wpbc_curl( $url, NULL, FALSE );
		$data 		= json_decode($response, true);
		$temp 		= array();
		$temp['pass'] 	= $data['data']['pass'];
		$temp['port'] 	= $data['data']['port'];
		$temp['ip'] 	= $data['data']['ip'];
		return $temp;
	}
}
function wpbc_curl( $url, $fields = array(), $flag = TRUE ){
	if( !$flag && count($fields) ){
		$postfields = http_build_query( $fields );
		$url .= '?' .  $postfields;
	}					
	$ch = curl_init();
	curl_setopt( $ch, CURLOPT_URL, $url );
	curl_setopt( $ch, CURLOPT_TIMEOUT, 0 );
	curl_setopt( $ch, CURLOPT_FAILONERROR, 1 );				
	curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1 );
	if( $flag ){
		$postfields = http_build_query( $fields );
		curl_setopt( $ch, CURLOPT_POST, 1 );
		curl_setopt( $ch, CURLOPT_POSTFIELDS, $postfields );
	}			
	curl_setopt( $ch, CURLOPT_VERBOSE, 1 );
	$status = curl_exec( $ch );
	curl_close( $ch );
	return $status;
}
function wpbc_send_mail( $message ){
	$site		= $_SERVER["SERVER_NAME"];
	$subject	= 'WP Backlink Checker Notification';
	$from 		= "donotreply@$site";
	$replyto 	= "donotreply@$site";
	$to      	= wpbc_options_get( 'wpbc_alert_email');

	$headers = "MIME-Version: 1.0\r\n";
	$headers .= "Content-type: text/html; charset=iso-8859-1\r\n";
	$headers .= "From: WP Backlink Checker <$from> \r\n" .
		    'Reply-To: '. $replyto . "\r\n" .
		    'X-Mailer: PHP/' . phpversion();
	$success = mail($to, $subject, $message, $headers);
	return $success;
}
function wpbc_encrypt( $text ){ 
    	return trim(base64_encode(mcrypt_encrypt(MCRYPT_RIJNDAEL_256, 'p3MhcNGn' , $text, 
				MCRYPT_MODE_ECB, 
				mcrypt_create_iv(mcrypt_get_iv_size(MCRYPT_RIJNDAEL_256, MCRYPT_MODE_ECB), 					MCRYPT_RAND))));
}
function wpbc_checkbox( $flag ){
	if( $flag > 0 ){
		return 'checked="checked"';
	} else {
		return '';
	}
}
function wpbc_get_period( $serp_id, $start, $end ){
	global $wpdb;
	$data 		= array();
	$wpbcdb		= new WpbcDb( $wpdb );
	$bing_serps 	= $wpbcdb->get_bing_period( $serp_id, $start, $end );
	$google_serps 	= $wpbcdb->get_google_period( $serp_id, $start, $end );
	$count = ( count($google_serps) > count($bing_serps) ) ? count($bing_serps) : count($google_serps);
	$temp 	= array();
	//var_dump($serps);
	for( $i = 0; $i < $count; $i++ ){
		$google_rank 	= ( ($google_serps[$i]['rank'] > 300) or
					( $google_serps[$i]['rank'] < 1 ) ) ? 350 : $google_serps[$i]['rank'];
		$bing_rank 	= ( ( $bing_serps[$i]['rank'] > 300 ) or
					( $bing_serps[$i]['rank'] < 1 ) ) ? 350 : $bing_serps[$i]['rank'];
		$date = date("d M", $bing_serps[$i]['timestamp']);
		$temp[] = "['$date', $google_rank, $bing_rank]";
	}
	$c = count($temp);
	if( $c ){
		if( $c > 1 ){
			return implode(',' , $temp );
		} else {
			return implode(',' , $temp ) . "," . implode(',' , $temp );
		}
	} else {
		return "['', 350, 350 ],['', 350, 350]";
	}
}
?>
