<?php
/*
	Plugin Name: WP Backlink Checker
	Version: 1.12
	Description: Easily monitor your backlinks with this plugin.
	Author: <a href="http://resell-rights-weekly.com">RRW</a>
*/

require_once dirname( __FILE__ ) . '/wpbc-functions.php';
require_once dirname( __FILE__ ) . '/wpbc-admin.php';
require_once dirname( __FILE__ ) . '/lib/WpbcDb.php';

register_activation_hook( __FILE__, 'wpbc_install' );

function wpbc_install(){
	global $wpdb;

	$wpbc_options = array();
	$wpbc_options = base64_encode(serialize($wpbc_options));
	add_option('wpbc_options', $wpbc_options);

	$backlinks_table		= $wpdb->prefix . "wpbc_backlinks";
	$backlinks_groups_table 	= $wpdb->prefix . "wpbc_backlinks_groups";


	$backlinks_table_sql = " CREATE TABLE IF NOT EXISTS " . $backlinks_table . " (
		id INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
		name VARCHAR( 255 ),
		group_id VARCHAR( 255 ),
		url text,
		site text,
		status text,
		expected_anchor text,
		discovered_anchor text,
		notify VARCHAR( 255 ),
		remind VARCHAR( 255 ),
		remind_last VARCHAR( 255 ),
		remind_days VARCHAR( 255 ),
		created VARCHAR( 255 ),
		timestamp VARCHAR( 255 )
		);";

	$backlinks_groups_table_sql = " CREATE TABLE IF NOT EXISTS " . $backlinks_groups_table . " (
		id INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
		name VARCHAR( 255 ),
		creator_id text,
		description text,
		notify VARCHAR( 255 ),
		remind VARCHAR( 255 ),
		remind_days VARCHAR( 255 ),
		timestamp VARCHAR( 255 )
		);";

	require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

	dbDelta( $backlinks_table_sql );
	dbDelta( $backlinks_groups_table_sql );

	global $current_user;
	get_currentuserinfo();
	wpbc_options_add( 'wpbc_alert_email', $current_user->user_email );
}
?>
